Unit MNN06_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNN06(var X :Array of Real; I :Integer; var P :Real;
                var IK :Integer; F :Real; var F1 :Real; F2 :Real;
                FE :Real; var NF :Integer; FUN :Proc_F1_MN; CD :Real;
                var ALPHA :Real);

implementation

procedure MNN06(var X :Array of Real; I :Integer; var P :Real;
                var IK :Integer; F :Real; var F1 :Real; F2 :Real;
                FE :Real; var NF :Integer; FUN :Proc_F1_MN; CD :Real;
                var ALPHA :Real);
var
AD,B1,F3,FE3,H,H1,H2 :Real;
label
_10,_20;
begin
{      OCTPOEHE APOKCMPYE APAO }
H := X[I-1];
B1 := ALPHA*CD;
H2 := X[I-1] + Sign(B1,P);
H1 := X[I-1] + Sign(ALPHA,P);
AD := -0.5*(F*(IntPower(H2,2) - IntPower(H1,2)) + F1*(IntPower(H,2) - IntPower(H2,2)) + F2*(IntPower(H1,2)))/(F*(H1 - H2) + F1*(H2 - H) + F2*(H - H1));
X[I-1] := AD;
NF := NF + 1;
FUN(X,F3,FE3);
if ( F3 >  F - FE ) 
 then goto _10;
F1 := F3;
ALPHA := Abs(H - AD);
X[I-1] := AD;
P := Sign(1.0,(AD-H));
goto _20;
_10:
IK := 0;
X[I-1] := H;
_20:
end;

end.
